---
title: Buy/Sell Holiday Request
product: PDF Generator
description: Get a printable buy sell holiday request form in PDF. Create editable or prefilled employee leave request forms using SurveyJS PDF Generator.
framework: Vanilla JS
source: https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/vanillajs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Buy/Sell Holiday Request (Vanilla JS)

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import { SurveyPDF } from "survey-pdf";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.questionsOnPageMode = "standard";
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

const survey = new Model(json);
survey.showCompleteButton = false;
survey.navigationButtonsLocation = "topBottom";
survey.addNavigationItem({
    id: "survey_save_as_file",
    title: "Download PDF",
    action: () => {
        saveSurveyToPdf("surveyResult.pdf", survey);
    }
});
survey.addNavigationItem({
    id: "survey_pdf_preview",
    title: "Preview PDF",
    visible: window.navigator.pdfViewerEnabled,
    action: () => {
        previewPdf(survey);
    }
});
survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Annual Leave Buy/Sell Application Form",
  "headerView": "advanced",
  "pages": [
    {
      "name": "section-one",
      "title": "Section 1: Employee Details and Application",
      "elements": [
        {
          "type": "panel",
          "name": "employee-details",
          "title": "Employee Details",
          "elements": [
            {
              "type": "text",
              "name": "employee-surname",
              "title": "Surname"
            },
            {
              "type": "text",
              "name": "employee-first-name",
              "title": "First Name"
            },
            {
              "type": "text",
              "name": "employee-job-title",
              "title": "Job Title"
            },
            {
              "type": "text",
              "name": "employee-band",
              "title": "Band / Grade"
            },
            {
              "type": "text",
              "name": "employee-email-address",
              "title": "Email Address",
              "inputType": "email"
            },
            {
              "type": "text",
              "name": "employee-phone-number",
              "title": "Phone Number"
            },
            {
              "type": "text",
              "name": "employee-work-address",
              "title": "Work Address"
            }
          ]
        },
        {
          "type": "panel",
          "name": "employee-manager-details",
          "title": "Department and Manager Details",
          "elements": [
            {
              "type": "text",
              "name": "directorate",
              "title": "Directorate"
            },
            {
              "type": "text",
              "name": "line-manager",
              "title": "Line Manager"
            },
            {
              "type": "text",
              "name": "base",
              "title": "Base / Location"
            },
            {
              "type": "text",
              "name": "ward-department",
              "title": "Ward or Department"
            },
            {
              "type": "text",
              "name": "assignment-number",
              "title": "Assignment Number",
              "description": "Enter your 8-digit assignment number (see your payslip)."
            },
            {
              "type": "text",
              "name": "contracted-hours",
              "title": "Contracted Hours of Employment",
              "inputType": "number"
            },
            {
              "type": "text",
              "name": "continuous-service-date",
              "title": "Continuous Service Date",
              "inputType": "date"
            },
            {
              "type": "checkbox",
              "name": "contract-type",
              "title": "Contract Type",
              "description": "Select all that apply.",
              "choices": [
                "Permanent",
                "Fixed-Term",
                "All year round",
                "Term-time only",
                "Annualized"
              ],
              "colCount": 2
            }
          ]
        },
        {
          "type": "panel",
          "name": "buying-panel",
          "title": "Request to Buy Annual Leave",
          "description": "If approved, your gross annual salary will be reduced in exchange for additional annual leave. The deduction will normally be spread across a 12-month period.",
          "elements": [
            {
              "type": "text",
              "name": "buy-hours",
              "title": "Number of hours of annual leave you wish to buy",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "panel",
          "name": "selling-panel",
          "title": "Request to Sell Annual Leave",
          "description": "If approved, you will give up the specified amount of annual leave and receive a payment in exchange.",
          "elements": [
            {
              "type": "text",
              "name": "sell-hours",
              "title": "Number of hours of annual leave you wish to sell (enter if applicable)",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "checkbox",
          "name": "lesser-proportion",
          "title": "Acceptance of Partial Approval",
          "choices": [
            "I understand that the full amount requested may not be approved. A smaller amount may be authorized instead. Tick this box if you would NOT accept a reduced amount and prefer the request to be declined."
          ]
        },
        {
          "type": "panel",
          "name": "reason-to-buy-sell",
          "title": "Reason for Application",
          "description": "Select the option that best describes your reason for buying or selling annual leave (complete the section that applies).",
          "elements": [
            {
              "type": "radiogroup",
              "name": "buy-reason",
              "title": "Reason for Buying Leave (if buying leave)",
              "choices": [
                "More time with family",
                "Travel",
                "Home improvements"
              ],
              "showOtherItem": true,
              "otherText": "Other (please specify)"
            },
            {
              "type": "radiogroup",
              "name": "sell-reason",
              "title": "Reason for Selling Leave (if selling leave)",
              "choices": [
                "Do not require full leave entitlement",
                "Prefer additional income"
              ],
              "showOtherItem": true,
              "otherText": "Other (please specify)"
            }
          ]
        }
      ]
    },
    {
      "name": "salary-sacrifice",
      "title": "Section 2: Salary Sacrifice Acknowledgement",
      "elements": [
        {
          "type": "panel",
          "name": "important-information",
          "title": "Important Information",
          "elements": [
            {
              "type": "html",
              "name": "salary-sacrifice-details",
              "html": "<p>The national pension scheme is based on career-average earnings rather than final salary. Participating in a salary sacrifice arrangement may reduce the salary used to calculate your pension.</p><p>The Trust cannot provide pension or financial advice. If you are unsure how salary sacrifice may affect you, consider seeking independent financial advice.</p>"
            },
            {
              "type": "checkbox",
              "name": "salary-sacrifice-checkbox",
              "title": "Select the statements that apply to you:",
              "choices": [
                "I have taken independent financial advice regarding the impact on my pension.",
                "I have chosen not to take independent financial advice.",
                "I am not a member of the pension scheme.",
                {
                  "value": "n/a",
                  "text": "Not applicable (for example, if selling annual leave only).",
                  "isExclusive": true
                }
              ]
            }
          ]
        },
        {
          "type": "panel",
          "name": "employee-signature",
          "title": "Employee Declaration and Signature",
          "elements": [
            {
              "type": "signaturepad",
              "name": "employee-sign",
              "title": "Employee Signature",
              "signatureHeight": 150
            },
            {
              "type": "text",
              "name": "employee-printed-name",
              "title": "Printed Name"
            },
            {
              "type": "text",
              "name": "employee-date",
              "title": "Date",
              "inputType": "date"
            },
            {
              "type": "html",
              "name": "forward-comment",
              "html": "<em>Please forward this form to your Line Manager for completion of Section 3.</em>"
            }
          ]
        }
      ]
    },
    {
      "name": "line-manager-page",
      "title": "Section 3: Line Manager Review",
      "elements": [
        {
          "type": "radiogroup",
          "name": "previous-annual-leave",
          "title": "Has the employee carried over annual leave from the previous year?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "multipletext",
          "name": "days-and-hours",
          "title": "If yes, specify the amount carried over",
          "items": [
            {
              "name": "days",
              "title": "Days",
              "inputType": "number"
            },
            {
              "name": "hours",
              "title": "Hours",
              "inputType": "number"
            }
          ],
          "itemTitleWidth": 50,
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "sickness-absence",
          "title": "Does the employee's sickness absence exceed Trust trigger points?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "comment",
          "name": "support-application-comment",
          "title": "If applicable, explain why you still support the employee's application"
        },
        {
          "type": "panel",
          "name": "line-manager-decision",
          "title": "Manager Decision",
          "elements": [
            {
              "type": "radiogroup",
              "name": "manager-decision",
              "title": "Decision",
              "choices": [
                "Support the application (subject to final checks)",
                "Do not support the application"
              ]
            },
            {
              "type": "radiogroup",
              "name": "partial-support",
              "title": "If full approval is not possible, indicate whether a partial request can be supported",
              "choices": [
                "Support partial request to buy leave",
                "Support partial request to sell leave",
                "Not applicable"
              ]
            },
            {
              "type": "text",
              "name": "hours-confirmed",
              "title": "If partially approved, specify the number of hours approved",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "comment",
          "name": "decision-rationale",
          "title": "Reason for Decision"
        },
        {
          "type": "signaturepad",
          "name": "line-manager-signature",
          "title": "Manager Signature",
          "signatureHeight": 150
        },
        {
          "type": "text",
          "name": "line-manager-printed-name",
          "title": "Printed Name"
        },
        {
          "type": "text",
          "name": "line-manager-date",
          "title": "Date",
          "inputType": "date"
        },
        {
          "type": "html",
          "name": "line-manager-comment",
          "html": "<b>Managers must not communicate the decision to the employee until the process is completed.</b>"
        }
      ]
    }
  ],
  "questionsOnPageMode": "singlePage"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-pdf": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/angular.md)
- [React](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/jquery.md)


---
title: Buy/Sell Holiday Request
product: PDF Generator
description: Get a printable buy sell holiday request form in PDF. Create editable or prefilled employee leave request forms using SurveyJS PDF Generator.
framework: Angular
source: https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/angular
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Buy/Sell Holiday Request (Angular)

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Annual Leave Buy/Sell Application Form",
  "headerView": "advanced",
  "pages": [
    {
      "name": "section-one",
      "title": "Section 1: Employee Details and Application",
      "elements": [
        {
          "type": "panel",
          "name": "employee-details",
          "title": "Employee Details",
          "elements": [
            {
              "type": "text",
              "name": "employee-surname",
              "title": "Surname"
            },
            {
              "type": "text",
              "name": "employee-first-name",
              "title": "First Name"
            },
            {
              "type": "text",
              "name": "employee-job-title",
              "title": "Job Title"
            },
            {
              "type": "text",
              "name": "employee-band",
              "title": "Band / Grade"
            },
            {
              "type": "text",
              "name": "employee-email-address",
              "title": "Email Address",
              "inputType": "email"
            },
            {
              "type": "text",
              "name": "employee-phone-number",
              "title": "Phone Number"
            },
            {
              "type": "text",
              "name": "employee-work-address",
              "title": "Work Address"
            }
          ]
        },
        {
          "type": "panel",
          "name": "employee-manager-details",
          "title": "Department and Manager Details",
          "elements": [
            {
              "type": "text",
              "name": "directorate",
              "title": "Directorate"
            },
            {
              "type": "text",
              "name": "line-manager",
              "title": "Line Manager"
            },
            {
              "type": "text",
              "name": "base",
              "title": "Base / Location"
            },
            {
              "type": "text",
              "name": "ward-department",
              "title": "Ward or Department"
            },
            {
              "type": "text",
              "name": "assignment-number",
              "title": "Assignment Number",
              "description": "Enter your 8-digit assignment number (see your payslip)."
            },
            {
              "type": "text",
              "name": "contracted-hours",
              "title": "Contracted Hours of Employment",
              "inputType": "number"
            },
            {
              "type": "text",
              "name": "continuous-service-date",
              "title": "Continuous Service Date",
              "inputType": "date"
            },
            {
              "type": "checkbox",
              "name": "contract-type",
              "title": "Contract Type",
              "description": "Select all that apply.",
              "choices": [
                "Permanent",
                "Fixed-Term",
                "All year round",
                "Term-time only",
                "Annualized"
              ],
              "colCount": 2
            }
          ]
        },
        {
          "type": "panel",
          "name": "buying-panel",
          "title": "Request to Buy Annual Leave",
          "description": "If approved, your gross annual salary will be reduced in exchange for additional annual leave. The deduction will normally be spread across a 12-month period.",
          "elements": [
            {
              "type": "text",
              "name": "buy-hours",
              "title": "Number of hours of annual leave you wish to buy",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "panel",
          "name": "selling-panel",
          "title": "Request to Sell Annual Leave",
          "description": "If approved, you will give up the specified amount of annual leave and receive a payment in exchange.",
          "elements": [
            {
              "type": "text",
              "name": "sell-hours",
              "title": "Number of hours of annual leave you wish to sell (enter if applicable)",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "checkbox",
          "name": "lesser-proportion",
          "title": "Acceptance of Partial Approval",
          "choices": [
            "I understand that the full amount requested may not be approved. A smaller amount may be authorized instead. Tick this box if you would NOT accept a reduced amount and prefer the request to be declined."
          ]
        },
        {
          "type": "panel",
          "name": "reason-to-buy-sell",
          "title": "Reason for Application",
          "description": "Select the option that best describes your reason for buying or selling annual leave (complete the section that applies).",
          "elements": [
            {
              "type": "radiogroup",
              "name": "buy-reason",
              "title": "Reason for Buying Leave (if buying leave)",
              "choices": [
                "More time with family",
                "Travel",
                "Home improvements"
              ],
              "showOtherItem": true,
              "otherText": "Other (please specify)"
            },
            {
              "type": "radiogroup",
              "name": "sell-reason",
              "title": "Reason for Selling Leave (if selling leave)",
              "choices": [
                "Do not require full leave entitlement",
                "Prefer additional income"
              ],
              "showOtherItem": true,
              "otherText": "Other (please specify)"
            }
          ]
        }
      ]
    },
    {
      "name": "salary-sacrifice",
      "title": "Section 2: Salary Sacrifice Acknowledgement",
      "elements": [
        {
          "type": "panel",
          "name": "important-information",
          "title": "Important Information",
          "elements": [
            {
              "type": "html",
              "name": "salary-sacrifice-details",
              "html": "<p>The national pension scheme is based on career-average earnings rather than final salary. Participating in a salary sacrifice arrangement may reduce the salary used to calculate your pension.</p><p>The Trust cannot provide pension or financial advice. If you are unsure how salary sacrifice may affect you, consider seeking independent financial advice.</p>"
            },
            {
              "type": "checkbox",
              "name": "salary-sacrifice-checkbox",
              "title": "Select the statements that apply to you:",
              "choices": [
                "I have taken independent financial advice regarding the impact on my pension.",
                "I have chosen not to take independent financial advice.",
                "I am not a member of the pension scheme.",
                {
                  "value": "n/a",
                  "text": "Not applicable (for example, if selling annual leave only).",
                  "isExclusive": true
                }
              ]
            }
          ]
        },
        {
          "type": "panel",
          "name": "employee-signature",
          "title": "Employee Declaration and Signature",
          "elements": [
            {
              "type": "signaturepad",
              "name": "employee-sign",
              "title": "Employee Signature",
              "signatureHeight": 150
            },
            {
              "type": "text",
              "name": "employee-printed-name",
              "title": "Printed Name"
            },
            {
              "type": "text",
              "name": "employee-date",
              "title": "Date",
              "inputType": "date"
            },
            {
              "type": "html",
              "name": "forward-comment",
              "html": "<em>Please forward this form to your Line Manager for completion of Section 3.</em>"
            }
          ]
        }
      ]
    },
    {
      "name": "line-manager-page",
      "title": "Section 3: Line Manager Review",
      "elements": [
        {
          "type": "radiogroup",
          "name": "previous-annual-leave",
          "title": "Has the employee carried over annual leave from the previous year?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "multipletext",
          "name": "days-and-hours",
          "title": "If yes, specify the amount carried over",
          "items": [
            {
              "name": "days",
              "title": "Days",
              "inputType": "number"
            },
            {
              "name": "hours",
              "title": "Hours",
              "inputType": "number"
            }
          ],
          "itemTitleWidth": 50,
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "sickness-absence",
          "title": "Does the employee's sickness absence exceed Trust trigger points?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "comment",
          "name": "support-application-comment",
          "title": "If applicable, explain why you still support the employee's application"
        },
        {
          "type": "panel",
          "name": "line-manager-decision",
          "title": "Manager Decision",
          "elements": [
            {
              "type": "radiogroup",
              "name": "manager-decision",
              "title": "Decision",
              "choices": [
                "Support the application (subject to final checks)",
                "Do not support the application"
              ]
            },
            {
              "type": "radiogroup",
              "name": "partial-support",
              "title": "If full approval is not possible, indicate whether a partial request can be supported",
              "choices": [
                "Support partial request to buy leave",
                "Support partial request to sell leave",
                "Not applicable"
              ]
            },
            {
              "type": "text",
              "name": "hours-confirmed",
              "title": "If partially approved, specify the number of hours approved",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "comment",
          "name": "decision-rationale",
          "title": "Reason for Decision"
        },
        {
          "type": "signaturepad",
          "name": "line-manager-signature",
          "title": "Manager Signature",
          "signatureHeight": 150
        },
        {
          "type": "text",
          "name": "line-manager-printed-name",
          "title": "Printed Name"
        },
        {
          "type": "text",
          "name": "line-manager-date",
          "title": "Date",
          "inputType": "date"
        },
        {
          "type": "html",
          "name": "line-manager-comment",
          "html": "<b>Managers must not communicate the decision to the employee until the process is completed.</b>"
        }
      ]
    }
  ],
  "questionsOnPageMode": "singlePage"
};
```

### `src/app/components/pdf.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/pdf.component.html`

```html
<survey [model]="model"></survey>
```

### `src/app/components/pdf.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { json } from "./json";
import "./pdf.component.css";
import "survey-core/survey-core.min.css";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.questionsOnPageMode = "standard";
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./pdf.component.html",
    styleUrls: ["./pdf.component.css"]
})
export class SurveyPdfComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.showCompleteButton = false;
        survey.navigationButtonsLocation = "topBottom";
        survey.addNavigationItem({
            id: "survey_save_as_file",
            title: "Download PDF",
            action: () => {
                saveSurveyToPdf("surveyResult.pdf", survey);
            }
        });
        survey.addNavigationItem({
            id: "survey_pdf_preview",
            title: "Preview PDF",
            visible: window.navigator.pdfViewerEnabled,
            action: () => {
                previewPdf(survey);
            }
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyPdfComponent } from "./components/pdf.component";

@NgModule({
    declarations: [AppComponent, SurveyPdfComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;">
        <app-root></app-root>
    </div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css

```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "survey-pdf": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/vanillajs.md)


---
title: Buy/Sell Holiday Request
product: PDF Generator
description: Get a printable buy sell holiday request form in PDF. Create editable or prefilled employee leave request forms using SurveyJS PDF Generator.
framework: React
source: https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/reactjs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Buy/Sell Holiday Request (React)

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/SurveyPdfComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.questionsOnPageMode = "standard";
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

function SurveyPdfComponent () {
    const survey = new Model(json);
    survey.showCompleteButton = false;
    survey.navigationButtonsLocation = "topBottom";
    survey.addNavigationItem({
        id: "survey_save_as_file",
        title: "Download PDF",
        action: () => {
            saveSurveyToPdf("surveyResult.pdf", survey);
        }
    });
    survey.addNavigationItem({
        id: "survey_pdf_preview",
        title: "Preview PDF",
        visible: window.navigator.pdfViewerEnabled,
        action: () => {
            previewPdf(survey);
        }
    });
    return (<Survey model={survey} />);
}

export default SurveyPdfComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyPdfComponent from "./SurveyPdfComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyPdfComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Annual Leave Buy/Sell Application Form",
  "headerView": "advanced",
  "pages": [
    {
      "name": "section-one",
      "title": "Section 1: Employee Details and Application",
      "elements": [
        {
          "type": "panel",
          "name": "employee-details",
          "title": "Employee Details",
          "elements": [
            {
              "type": "text",
              "name": "employee-surname",
              "title": "Surname"
            },
            {
              "type": "text",
              "name": "employee-first-name",
              "title": "First Name"
            },
            {
              "type": "text",
              "name": "employee-job-title",
              "title": "Job Title"
            },
            {
              "type": "text",
              "name": "employee-band",
              "title": "Band / Grade"
            },
            {
              "type": "text",
              "name": "employee-email-address",
              "title": "Email Address",
              "inputType": "email"
            },
            {
              "type": "text",
              "name": "employee-phone-number",
              "title": "Phone Number"
            },
            {
              "type": "text",
              "name": "employee-work-address",
              "title": "Work Address"
            }
          ]
        },
        {
          "type": "panel",
          "name": "employee-manager-details",
          "title": "Department and Manager Details",
          "elements": [
            {
              "type": "text",
              "name": "directorate",
              "title": "Directorate"
            },
            {
              "type": "text",
              "name": "line-manager",
              "title": "Line Manager"
            },
            {
              "type": "text",
              "name": "base",
              "title": "Base / Location"
            },
            {
              "type": "text",
              "name": "ward-department",
              "title": "Ward or Department"
            },
            {
              "type": "text",
              "name": "assignment-number",
              "title": "Assignment Number",
              "description": "Enter your 8-digit assignment number (see your payslip)."
            },
            {
              "type": "text",
              "name": "contracted-hours",
              "title": "Contracted Hours of Employment",
              "inputType": "number"
            },
            {
              "type": "text",
              "name": "continuous-service-date",
              "title": "Continuous Service Date",
              "inputType": "date"
            },
            {
              "type": "checkbox",
              "name": "contract-type",
              "title": "Contract Type",
              "description": "Select all that apply.",
              "choices": [
                "Permanent",
                "Fixed-Term",
                "All year round",
                "Term-time only",
                "Annualized"
              ],
              "colCount": 2
            }
          ]
        },
        {
          "type": "panel",
          "name": "buying-panel",
          "title": "Request to Buy Annual Leave",
          "description": "If approved, your gross annual salary will be reduced in exchange for additional annual leave. The deduction will normally be spread across a 12-month period.",
          "elements": [
            {
              "type": "text",
              "name": "buy-hours",
              "title": "Number of hours of annual leave you wish to buy",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "panel",
          "name": "selling-panel",
          "title": "Request to Sell Annual Leave",
          "description": "If approved, you will give up the specified amount of annual leave and receive a payment in exchange.",
          "elements": [
            {
              "type": "text",
              "name": "sell-hours",
              "title": "Number of hours of annual leave you wish to sell (enter if applicable)",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "checkbox",
          "name": "lesser-proportion",
          "title": "Acceptance of Partial Approval",
          "choices": [
            "I understand that the full amount requested may not be approved. A smaller amount may be authorized instead. Tick this box if you would NOT accept a reduced amount and prefer the request to be declined."
          ]
        },
        {
          "type": "panel",
          "name": "reason-to-buy-sell",
          "title": "Reason for Application",
          "description": "Select the option that best describes your reason for buying or selling annual leave (complete the section that applies).",
          "elements": [
            {
              "type": "radiogroup",
              "name": "buy-reason",
              "title": "Reason for Buying Leave (if buying leave)",
              "choices": [
                "More time with family",
                "Travel",
                "Home improvements"
              ],
              "showOtherItem": true,
              "otherText": "Other (please specify)"
            },
            {
              "type": "radiogroup",
              "name": "sell-reason",
              "title": "Reason for Selling Leave (if selling leave)",
              "choices": [
                "Do not require full leave entitlement",
                "Prefer additional income"
              ],
              "showOtherItem": true,
              "otherText": "Other (please specify)"
            }
          ]
        }
      ]
    },
    {
      "name": "salary-sacrifice",
      "title": "Section 2: Salary Sacrifice Acknowledgement",
      "elements": [
        {
          "type": "panel",
          "name": "important-information",
          "title": "Important Information",
          "elements": [
            {
              "type": "html",
              "name": "salary-sacrifice-details",
              "html": "<p>The national pension scheme is based on career-average earnings rather than final salary. Participating in a salary sacrifice arrangement may reduce the salary used to calculate your pension.</p><p>The Trust cannot provide pension or financial advice. If you are unsure how salary sacrifice may affect you, consider seeking independent financial advice.</p>"
            },
            {
              "type": "checkbox",
              "name": "salary-sacrifice-checkbox",
              "title": "Select the statements that apply to you:",
              "choices": [
                "I have taken independent financial advice regarding the impact on my pension.",
                "I have chosen not to take independent financial advice.",
                "I am not a member of the pension scheme.",
                {
                  "value": "n/a",
                  "text": "Not applicable (for example, if selling annual leave only).",
                  "isExclusive": true
                }
              ]
            }
          ]
        },
        {
          "type": "panel",
          "name": "employee-signature",
          "title": "Employee Declaration and Signature",
          "elements": [
            {
              "type": "signaturepad",
              "name": "employee-sign",
              "title": "Employee Signature",
              "signatureHeight": 150
            },
            {
              "type": "text",
              "name": "employee-printed-name",
              "title": "Printed Name"
            },
            {
              "type": "text",
              "name": "employee-date",
              "title": "Date",
              "inputType": "date"
            },
            {
              "type": "html",
              "name": "forward-comment",
              "html": "<em>Please forward this form to your Line Manager for completion of Section 3.</em>"
            }
          ]
        }
      ]
    },
    {
      "name": "line-manager-page",
      "title": "Section 3: Line Manager Review",
      "elements": [
        {
          "type": "radiogroup",
          "name": "previous-annual-leave",
          "title": "Has the employee carried over annual leave from the previous year?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "multipletext",
          "name": "days-and-hours",
          "title": "If yes, specify the amount carried over",
          "items": [
            {
              "name": "days",
              "title": "Days",
              "inputType": "number"
            },
            {
              "name": "hours",
              "title": "Hours",
              "inputType": "number"
            }
          ],
          "itemTitleWidth": 50,
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "sickness-absence",
          "title": "Does the employee's sickness absence exceed Trust trigger points?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "comment",
          "name": "support-application-comment",
          "title": "If applicable, explain why you still support the employee's application"
        },
        {
          "type": "panel",
          "name": "line-manager-decision",
          "title": "Manager Decision",
          "elements": [
            {
              "type": "radiogroup",
              "name": "manager-decision",
              "title": "Decision",
              "choices": [
                "Support the application (subject to final checks)",
                "Do not support the application"
              ]
            },
            {
              "type": "radiogroup",
              "name": "partial-support",
              "title": "If full approval is not possible, indicate whether a partial request can be supported",
              "choices": [
                "Support partial request to buy leave",
                "Support partial request to sell leave",
                "Not applicable"
              ]
            },
            {
              "type": "text",
              "name": "hours-confirmed",
              "title": "If partially approved, specify the number of hours approved",
              "inputType": "number"
            }
          ]
        },
        {
          "type": "comment",
          "name": "decision-rationale",
          "title": "Reason for Decision"
        },
        {
          "type": "signaturepad",
          "name": "line-manager-signature",
          "title": "Manager Signature",
          "signatureHeight": 150
        },
        {
          "type": "text",
          "name": "line-manager-printed-name",
          "title": "Printed Name"
        },
        {
          "type": "text",
          "name": "line-manager-date",
          "title": "Date",
          "inputType": "date"
        },
        {
          "type": "html",
          "name": "line-manager-comment",
          "html": "<b>Managers must not communicate the decision to the employee until the process is completed.</b>"
        }
      ]
    }
  ],
  "questionsOnPageMode": "singlePage"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-pdf": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/angular.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/pdf-hr-buy-sell-holiday-request-form-template/vanillajs.md)
